Index: po/LINGUAS
===================================================================
--- po/LINGUAS	(revision 130)
+++ po/LINGUAS	(revision 130)
@@ -0,0 +1,1 @@
+hu
Index: po/Makevars
===================================================================
--- po/Makevars	(revision 130)
+++ po/Makevars	(revision 130)
@@ -0,0 +1,41 @@
+# Makefile variables for PO directory in any package using GNU gettext.
+
+# Usually the message domain is the same as the package name.
+DOMAIN = $(PACKAGE)
+
+# These two variables depend on the location of this directory.
+subdir = po
+top_builddir = ..
+
+# These options get passed to xgettext.
+XGETTEXT_OPTIONS = --keyword=_ --keyword=N_
+
+# This is the copyright holder that gets inserted into the header of the
+# $(DOMAIN).pot file.  Set this to the copyright holder of the surrounding
+# package.  (Note that the msgstr strings, extracted from the package's
+# sources, belong to the copyright holder of the package.)  Translators are
+# expected to transfer the copyright for their translations to this person
+# or entity, or to disclaim their copyright.  The empty string stands for
+# the public domain; in this case the translators are expected to disclaim
+# their copyright.
+COPYRIGHT_HOLDER = Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+
+# This is the email address or URL to which the translators shall report
+# bugs in the untranslated strings:
+# - Strings which are not entire sentences, see the maintainer guidelines
+#   in the GNU gettext documentation, section 'Preparing Strings'.
+# - Strings which use unclear terms or require additional context to be
+#   understood.
+# - Strings which make invalid assumptions about notation of date, time or
+#   money.
+# - Pluralisation problems.
+# - Incorrect English spelling.
+# - Incorrect formatting.
+# It can be your email address, or a mailing list address where translators
+# can write to without being subscribed, or the URL of a web page through
+# which the translators can contact you.
+MSGID_BUGS_ADDRESS = $(PACKAGE_BUGREPORT)
+
+# This is the list of locale categories, beyond LC_MESSAGES, for which the
+# message catalogs shall be used.  It is usually empty.
+EXTRA_LOCALE_CATEGORIES =
Index: po/POTFILES.in
===================================================================
--- po/POTFILES.in	(revision 138)
+++ po/POTFILES.in	(revision 138)
@@ -0,0 +1,35 @@
+# List of source files which contain translatable strings.
+gui/algobox.cc
+gui/algobox.h
+gui/algowin.cc
+gui/algowin.h
+gui/all_include.h
+gui/gdc-broken_edge.cc
+gui/gettext.h
+gui/graph_displayer_canvas.cc
+gui/graph_displayer_canvas-edge.cc
+gui/graph_displayer_canvas-event.cc
+gui/graph_displayer_canvas.h
+gui/graph_displayer_canvas-node.cc
+gui/graph_displayer_canvas-zoom.cc
+gui/graph-displayer.cc
+gui/gui_reader.cc
+gui/gui_reader.h
+gui/gui_writer.cc
+gui/gui_writer.h
+gui/kruskalbox.cc
+gui/kruskalbox.h
+gui/main_win.cc
+gui/main_win.h
+gui/mapselector.cc
+gui/mapselector.h
+gui/mapstorage.cc
+gui/mapstorage.h
+gui/map_win.cc
+gui/map_win.h
+gui/nbtab.cc
+gui/nbtab.h
+gui/new_map_win.cc
+gui/new_map_win.h
+gui/xml.h
+gui/xymap.h
Index: po/hu.po
===================================================================
--- po/hu.po	(revision 138)
+++ po/hu.po	(revision 138)
@@ -0,0 +1,89 @@
+# Hungarian translations for LEMON package.
+# Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+# This file is distributed under the same license as the LEMON package.
+# Ladanyi Akos <ladanyi@tmit.bme.hu>, 2006.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: LEMON svn-head\n"
+"Report-Msgid-Bugs-To: etik-ol@cs.elte.hu\n"
+"POT-Creation-Date: 2006-04-14 20:37+0200\n"
+"PO-Revision-Date: 2006-03-22 15:55+0100\n"
+"Last-Translator: Ladanyi Akos <ladanyi@tmit.bme.hu>\n"
+"Language-Team: Hungarian <translation-team-hu@lists.sourceforge.net>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=1; plural=0;\n"
+
+#: gui/main_win.cc:80
+msgid "_File"
+msgstr "_FÃ¡jl"
+
+#: gui/main_win.cc:85
+msgid "Clear Tab"
+msgstr "Lap tÃ¶rlÃ©se"
+
+#: gui/main_win.cc:96
+msgid "_View"
+msgstr "_NÃ©zet"
+
+#: gui/main_win.cc:106
+msgid "_Show"
+msgstr "_Mutat"
+
+#: gui/main_win.cc:107
+msgid "_Maps"
+msgstr "_Mapek"
+
+#: gui/main_win.cc:110
+msgid "_Algorithms"
+msgstr "_Algoritmusok"
+
+#: gui/main_win.cc:111
+msgid "_General"
+msgstr "_ÃltalÃ¡nos"
+
+#: gui/main_win.cc:113
+msgid "_Kruskal"
+msgstr "_Kruskal"
+
+#: gui/main_win.cc:117
+msgid "Move"
+msgstr "Mozgat"
+
+#: gui/main_win.cc:119
+msgid "Create node"
+msgstr "CsÃºcs lÃ©trehozÃ¡sa"
+
+#: gui/main_win.cc:121
+msgid "Create edge"
+msgstr "Ãl lÃ©trehozÃ¡sa"
+
+#: gui/main_win.cc:123
+msgid "Delete"
+msgstr "TÃ¶rlÃ©s"
+
+#: gui/main_win.cc:126
+msgid "Edit edge map"
+msgstr "Ãl map szerkesztÃ©se"
+
+#: gui/main_win.cc:128
+msgid "Edit node map"
+msgstr "CsÃºcs map szerkesztÃ©se"
+
+#: gui/main_win.cc:259
+msgid "unsaved file"
+msgstr "nem mentett fÃ¡jl"
+
+#: gui/main_win.cc:269
+msgid "<b>Save changes before closing?</b>"
+msgstr "Menti a vÃ¡ltozÃ¡sokat mielÅtt bezÃ¡rja?"
+
+#: gui/main_win.cc:271
+msgid "Close file _without Saving"
+msgstr "BezÃ¡rÃ¡s mentÃ©s _nÃ©kÃŒl"
+
+#: gui/main_win.cc:458 gui/main_win.cc:487
+msgid "Create New Map - "
+msgstr "Ãj map lÃ©trehozÃ¡sa - "
Index: po/lemon.pot
===================================================================
--- po/lemon.pot	(revision 138)
+++ po/lemon.pot	(revision 138)
@@ -0,0 +1,89 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+# This file is distributed under the same license as the PACKAGE package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: PACKAGE VERSION\n"
+"Report-Msgid-Bugs-To: etik-ol@cs.elte.hu\n"
+"POT-Creation-Date: 2006-04-14 20:37+0200\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=CHARSET\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#: gui/main_win.cc:80
+msgid "_File"
+msgstr ""
+
+#: gui/main_win.cc:85
+msgid "Clear Tab"
+msgstr ""
+
+#: gui/main_win.cc:96
+msgid "_View"
+msgstr ""
+
+#: gui/main_win.cc:106
+msgid "_Show"
+msgstr ""
+
+#: gui/main_win.cc:107
+msgid "_Maps"
+msgstr ""
+
+#: gui/main_win.cc:110
+msgid "_Algorithms"
+msgstr ""
+
+#: gui/main_win.cc:111
+msgid "_General"
+msgstr ""
+
+#: gui/main_win.cc:113
+msgid "_Kruskal"
+msgstr ""
+
+#: gui/main_win.cc:117
+msgid "Move"
+msgstr ""
+
+#: gui/main_win.cc:119
+msgid "Create node"
+msgstr ""
+
+#: gui/main_win.cc:121
+msgid "Create edge"
+msgstr ""
+
+#: gui/main_win.cc:123
+msgid "Delete"
+msgstr ""
+
+#: gui/main_win.cc:126
+msgid "Edit edge map"
+msgstr ""
+
+#: gui/main_win.cc:128
+msgid "Edit node map"
+msgstr ""
+
+#: gui/main_win.cc:259
+msgid "unsaved file"
+msgstr ""
+
+#: gui/main_win.cc:269
+msgid "<b>Save changes before closing?</b>"
+msgstr ""
+
+#: gui/main_win.cc:271
+msgid "Close file _without Saving"
+msgstr ""
+
+#: gui/main_win.cc:458 gui/main_win.cc:487
+msgid "Create New Map - "
+msgstr ""