Index: Makefile.am
===================================================================
--- Makefile.am	(revision 133)
+++ Makefile.am	(revision 139)
@@ -1,4 +1,5 @@
 AM_CPPFLAGS = -I$(top_srcdir) -DLOCALEDIR=\""$(datadir)/locale"\"
-LDADD = $(top_builddir)/lemon/libemon.la
+
+SUBDIRS = po m4
 
 bin_PROGRAMS = glemon
@@ -44,6 +45,6 @@
 	gettext.h
 
-glemon_CXXFLAGS = $(GTK_CFLAGS)
-glemon_LDFLAGS = $(GTK_LIBS)
+glemon_CXXFLAGS = $(GTK_CFLAGS) $(LEMON_CFLAGS)
+glemon_LDFLAGS = $(GTK_LIBS) $(LEMON_LIBS)
 glemon_LDADD = $(LIBINTL)
 
@@ -71,3 +72,65 @@
 	( rm -f guipixbufs.h && false )
 
-EXTRA_DIST = $(IMAGES) guipixbufs.h
+EXTRA_DIST = \
+	$(IMAGES) \
+	guipixbufs.h \
+	ABOUT-NLS
+
+MRPROPERFILES = \
+	Makefile.in \
+	configure \
+	config.h.in \
+	aclocal.m4 \
+	ABOUT-NLS \
+	m4/Makefile.in \
+	m4/lib-link.m4 \
+	m4/printf-posix.m4 \
+	m4/uintmax_t.m4 \
+	m4/signed.m4 \
+	m4/iconv.m4 \
+	m4/inttypes.m4 \
+	m4/longlong.m4 \
+	m4/glibc21.m4 \
+	m4/inttypes_h.m4 \
+	m4/codeset.m4 \
+	m4/longdouble.m4 \
+	m4/nls.m4 \
+	m4/intmax.m4 \
+	m4/lib-prefix.m4 \
+	m4/glibc2.m4 \
+	m4/xsize.m4 \
+	m4/lcmessage.m4 \
+	m4/lib-ld.m4 \
+	m4/ulonglong.m4 \
+	m4/wint_t.m4 \
+	m4/progtest.m4 \
+	m4/inttypes-pri.m4 \
+	m4/stdint_h.m4 \
+	m4/intdiv0.m4 \
+	m4/isc-posix.m4 \
+	m4/po.m4 \
+	m4/size_max.m4 \
+	m4/gettext.m4 \
+	m4/wchar_t.m4 \
+	po/Rules-quot \
+	po/en@quot.header \
+	po/insert-header.sin \
+	po/quot.sed \
+	po/en@boldquot.header \
+	po/boldquot.sed \
+	po/Makevars.template \
+	po/remove-potcdate.sin \
+	po/Makefile.in.in \
+	build-aux/mkinstalldirs \
+	build-aux/config.rpath \
+	build-aux/depcomp \
+	build-aux/missing \
+	build-aux/config.guess \
+	build-aux/config.sub \
+	build-aux/install-sh
+
+mrproper:
+	$(MAKE) $(AM_MAKEFLAGS) maintainer-clean
+	-rm -f $(MRPROPERFILES)
+
+.PHONY: mrproper
Index: bootstrap
===================================================================
--- bootstrap	(revision 139)
+++ bootstrap	(revision 139)
@@ -0,0 +1,85 @@
+#!/bin/bash
+
+quiet=0
+function quiet { [[ $quiet == 1 ]]; }
+
+if [[ "$1" == "-q" ]]; then
+  quiet=1
+  shift
+fi
+
+prev=
+for option
+do
+  if test -n "$prev"
+  then
+    eval "$prev=\$option"
+    prev=
+    continue
+  fi
+
+  optarg=`expr "x$option" : 'x[^=]*=\(.*\)'`
+
+  case $option in
+
+  -amver | --amver)
+    prev=amver ;;
+  -amver=* | --amver=*)
+    amver=$optarg ;;
+
+  -acver | --acver)
+    prev=acver ;;
+  -acver=* | --acver=*)
+    acver=$optarg ;;
+
+  --help | -h)
+    cat << EOF
+Usage: $0 [OPTION]
+
+Options:
+  -h, --help            display this help and exit
+      --amver=VERSION   use VERSION version of automake
+      --acver=VERSION   use VERSION version of autoconf
+
+Expamle:
+  $0 --amver=1.8 --acver=2.59
+EOF
+    exit 0
+    ;;
+
+  *)
+    cat << EOF >&2
+$0: unrecognized option: $option
+Try \`$0 --help' for more information.
+EOF
+    exit 1
+    ;;
+
+  esac
+done
+
+automake=automake
+aclocal=aclocal
+autoconf=autoconf
+autoheader=autoheader
+
+if test -n "$amver"
+then
+  automake=automake-$amver
+  aclocal=aclocal-$amver
+fi
+
+if test -n "$acver"
+then
+  autoconf=autoconf-$acver
+  autoheader=autoheader-$acver
+fi
+
+set -e
+quiet || set -x
+
+autopoint
+$aclocal -I m4
+$autoconf
+$autoheader
+$automake --add-missing --copy --gnu
Index: configure.ac
===================================================================
--- configure.ac	(revision 139)
+++ configure.ac	(revision 139)
@@ -0,0 +1,36 @@
+dnl Process this file with autoconf to produce a configure script.
+AC_PREREQ([2.59])
+AC_INIT([gLEMON], [svn-head], [etik-ol@cs.elte.hu], [glemon])
+AC_CONFIG_AUX_DIR([build-aux])
+AC_CONFIG_MACRO_DIR([m4])
+AM_INIT_AUTOMAKE([-Wall -Werror foreign])
+AC_CONFIG_SRCDIR([main_win.h])
+AC_CONFIG_HEADERS([config.h])
+
+dnl Checks for programs.
+AC_PROG_CXX
+AC_PROG_CC
+AM_GNU_GETTEXT_VERSION([0.14.2])
+AM_GNU_GETTEXT([external])
+
+dnl Checks for libraries.
+PKG_CHECK_MODULES([GTK], [libgnomecanvasmm-2.6 >= 2.6.0 gtkmm-2.4 >= 2.6])
+PKG_CHECK_MODULES([LEMON], [lemon >= 0.5])
+
+dnl Checks for header files.
+AC_CHECK_HEADERS([libintl.h locale.h])
+
+dnl Checks for typedefs, structures, and compiler characteristics.
+AC_HEADER_STDBOOL
+AC_C_CONST
+
+dnl Checks for library functions.
+AC_CHECK_FUNCS([setlocale sqrt])
+
+AC_CONFIG_FILES([
+Makefile
+po/Makefile.in
+m4/Makefile
+])
+
+AC_OUTPUT
Index: m4/Makefile.am
===================================================================
--- m4/Makefile.am	(revision 139)
+++ m4/Makefile.am	(revision 139)
@@ -0,0 +1,30 @@
+EXTRA_DIST = \
+	codeset.m4 \
+	gettext.m4 \
+	glibc21.m4 \
+	glibc2.m4 \
+	iconv.m4 \
+	intdiv0.m4 \
+	intmax.m4 \
+	inttypes_h.m4 \
+	inttypes.m4 \
+	inttypes-pri.m4 \
+	isc-posix.m4 \
+	lcmessage.m4 \
+	lib-ld.m4 \
+	lib-link.m4 \
+	lib-prefix.m4 \
+	longdouble.m4 \
+	longlong.m4 \
+	nls.m4 \
+	po.m4 \
+	printf-posix.m4 \
+	progtest.m4 \
+	signed.m4 \
+	size_max.m4 \
+	stdint_h.m4 \
+	uintmax_t.m4 \
+	ulonglong.m4 \
+	wchar_t.m4 \
+	wint_t.m4 \
+	xsize.m4
Index: po/POTFILES.in
===================================================================
--- po/POTFILES.in	(revision 138)
+++ po/POTFILES.in	(revision 139)
@@ -1,35 +1,35 @@
 # List of source files which contain translatable strings.
-gui/algobox.cc
-gui/algobox.h
-gui/algowin.cc
-gui/algowin.h
-gui/all_include.h
-gui/gdc-broken_edge.cc
-gui/gettext.h
-gui/graph_displayer_canvas.cc
-gui/graph_displayer_canvas-edge.cc
-gui/graph_displayer_canvas-event.cc
-gui/graph_displayer_canvas.h
-gui/graph_displayer_canvas-node.cc
-gui/graph_displayer_canvas-zoom.cc
-gui/graph-displayer.cc
-gui/gui_reader.cc
-gui/gui_reader.h
-gui/gui_writer.cc
-gui/gui_writer.h
-gui/kruskalbox.cc
-gui/kruskalbox.h
-gui/main_win.cc
-gui/main_win.h
-gui/mapselector.cc
-gui/mapselector.h
-gui/mapstorage.cc
-gui/mapstorage.h
-gui/map_win.cc
-gui/map_win.h
-gui/nbtab.cc
-gui/nbtab.h
-gui/new_map_win.cc
-gui/new_map_win.h
-gui/xml.h
-gui/xymap.h
+algobox.cc
+algobox.h
+algowin.cc
+algowin.h
+all_include.h
+gdc-broken_edge.cc
+gettext.h
+graph_displayer_canvas.cc
+graph_displayer_canvas-edge.cc
+graph_displayer_canvas-event.cc
+graph_displayer_canvas.h
+graph_displayer_canvas-node.cc
+graph_displayer_canvas-zoom.cc
+graph-displayer.cc
+gui_reader.cc
+gui_reader.h
+gui_writer.cc
+gui_writer.h
+kruskalbox.cc
+kruskalbox.h
+main_win.cc
+main_win.h
+mapselector.cc
+mapselector.h
+mapstorage.cc
+mapstorage.h
+map_win.cc
+map_win.h
+nbtab.cc
+nbtab.h
+new_map_win.cc
+new_map_win.h
+xml.h
+xymap.h
Index: po/glemon.pot
===================================================================
--- po/glemon.pot	(revision 139)
+++ po/glemon.pot	(revision 139)
@@ -0,0 +1,89 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+# This file is distributed under the same license as the PACKAGE package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: PACKAGE VERSION\n"
+"Report-Msgid-Bugs-To: etik-ol@cs.elte.hu\n"
+"POT-Creation-Date: 2006-04-14 20:37+0200\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=CHARSET\n"
+"Content-Transfer-Encoding: 8bit\n"
+
+#: main_win.cc:80
+msgid "_File"
+msgstr ""
+
+#: main_win.cc:85
+msgid "Clear Tab"
+msgstr ""
+
+#: main_win.cc:96
+msgid "_View"
+msgstr ""
+
+#: main_win.cc:106
+msgid "_Show"
+msgstr ""
+
+#: main_win.cc:107
+msgid "_Maps"
+msgstr ""
+
+#: main_win.cc:110
+msgid "_Algorithms"
+msgstr ""
+
+#: main_win.cc:111
+msgid "_General"
+msgstr ""
+
+#: main_win.cc:113
+msgid "_Kruskal"
+msgstr ""
+
+#: main_win.cc:117
+msgid "Move"
+msgstr ""
+
+#: main_win.cc:119
+msgid "Create node"
+msgstr ""
+
+#: main_win.cc:121
+msgid "Create edge"
+msgstr ""
+
+#: main_win.cc:123
+msgid "Delete"
+msgstr ""
+
+#: main_win.cc:126
+msgid "Edit edge map"
+msgstr ""
+
+#: main_win.cc:128
+msgid "Edit node map"
+msgstr ""
+
+#: main_win.cc:259
+msgid "unsaved file"
+msgstr ""
+
+#: main_win.cc:269
+msgid "<b>Save changes before closing?</b>"
+msgstr ""
+
+#: main_win.cc:271
+msgid "Close file _without Saving"
+msgstr ""
+
+#: main_win.cc:458 main_win.cc:487
+msgid "Create New Map - "
+msgstr ""
Index: po/hu.po
===================================================================
--- po/hu.po	(revision 138)
+++ po/hu.po	(revision 139)
@@ -6,5 +6,5 @@
 msgid ""
 msgstr ""
-"Project-Id-Version: LEMON svn-head\n"
+"Project-Id-Version: gLEMON svn-head\n"
 "Report-Msgid-Bugs-To: etik-ol@cs.elte.hu\n"
 "POT-Creation-Date: 2006-04-14 20:37+0200\n"
@@ -17,73 +17,73 @@
 "Plural-Forms: nplurals=1; plural=0;\n"
 
-#: gui/main_win.cc:80
+#: main_win.cc:80
 msgid "_File"
 msgstr "_FÃ¡jl"
 
-#: gui/main_win.cc:85
+#: main_win.cc:85
 msgid "Clear Tab"
 msgstr "Lap tÃ¶rlÃ©se"
 
-#: gui/main_win.cc:96
+#: main_win.cc:96
 msgid "_View"
 msgstr "_NÃ©zet"
 
-#: gui/main_win.cc:106
+#: main_win.cc:106
 msgid "_Show"
 msgstr "_Mutat"
 
-#: gui/main_win.cc:107
+#: main_win.cc:107
 msgid "_Maps"
 msgstr "_Mapek"
 
-#: gui/main_win.cc:110
+#: main_win.cc:110
 msgid "_Algorithms"
 msgstr "_Algoritmusok"
 
-#: gui/main_win.cc:111
+#: main_win.cc:111
 msgid "_General"
 msgstr "_ÃltalÃ¡nos"
 
-#: gui/main_win.cc:113
+#: main_win.cc:113
 msgid "_Kruskal"
 msgstr "_Kruskal"
 
-#: gui/main_win.cc:117
+#: main_win.cc:117
 msgid "Move"
 msgstr "Mozgat"
 
-#: gui/main_win.cc:119
+#: main_win.cc:119
 msgid "Create node"
 msgstr "CsÃºcs lÃ©trehozÃ¡sa"
 
-#: gui/main_win.cc:121
+#: main_win.cc:121
 msgid "Create edge"
 msgstr "Ãl lÃ©trehozÃ¡sa"
 
-#: gui/main_win.cc:123
+#: main_win.cc:123
 msgid "Delete"
 msgstr "TÃ¶rlÃ©s"
 
-#: gui/main_win.cc:126
+#: main_win.cc:126
 msgid "Edit edge map"
 msgstr "Ãl map szerkesztÃ©se"
 
-#: gui/main_win.cc:128
+#: main_win.cc:128
 msgid "Edit node map"
 msgstr "CsÃºcs map szerkesztÃ©se"
 
-#: gui/main_win.cc:259
+#: main_win.cc:259
 msgid "unsaved file"
 msgstr "nem mentett fÃ¡jl"
 
-#: gui/main_win.cc:269
+#: main_win.cc:269
 msgid "<b>Save changes before closing?</b>"
 msgstr "Menti a vÃ¡ltozÃ¡sokat mielÅtt bezÃ¡rja?"
 
-#: gui/main_win.cc:271
+#: main_win.cc:271
 msgid "Close file _without Saving"
 msgstr "BezÃ¡rÃ¡s mentÃ©s _nÃ©kÃŒl"
 
-#: gui/main_win.cc:458 gui/main_win.cc:487
+#: main_win.cc:458 main_win.cc:487
 msgid "Create New Map - "
 msgstr "Ãj map lÃ©trehozÃ¡sa - "
Index: lemon.pot
===================================================================
--- po/lemon.pot	(revision 138)
+++ 	(revision )
@@ -1,89 +1,0 @@
-# SOME DESCRIPTIVE TITLE.
-# Copyright (C) YEAR Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
-# This file is distributed under the same license as the PACKAGE package.
-# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
-#
-#, fuzzy
-msgid ""
-msgstr ""
-"Project-Id-Version: PACKAGE VERSION\n"
-"Report-Msgid-Bugs-To: etik-ol@cs.elte.hu\n"
-"POT-Creation-Date: 2006-04-14 20:37+0200\n"
-"PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
-"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
-"Language-Team: LANGUAGE <LL@li.org>\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=CHARSET\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#: gui/main_win.cc:80
-msgid "_File"
-msgstr ""
-
-#: gui/main_win.cc:85
-msgid "Clear Tab"
-msgstr ""
-
-#: gui/main_win.cc:96
-msgid "_View"
-msgstr ""
-
-#: gui/main_win.cc:106
-msgid "_Show"
-msgstr ""
-
-#: gui/main_win.cc:107
-msgid "_Maps"
-msgstr ""
-
-#: gui/main_win.cc:110
-msgid "_Algorithms"
-msgstr ""
-
-#: gui/main_win.cc:111
-msgid "_General"
-msgstr ""
-
-#: gui/main_win.cc:113
-msgid "_Kruskal"
-msgstr ""
-
-#: gui/main_win.cc:117
-msgid "Move"
-msgstr ""
-
-#: gui/main_win.cc:119
-msgid "Create node"
-msgstr ""
-
-#: gui/main_win.cc:121
-msgid "Create edge"
-msgstr ""
-
-#: gui/main_win.cc:123
-msgid "Delete"
-msgstr ""
-
-#: gui/main_win.cc:126
-msgid "Edit edge map"
-msgstr ""
-
-#: gui/main_win.cc:128
-msgid "Edit node map"
-msgstr ""
-
-#: gui/main_win.cc:259
-msgid "unsaved file"
-msgstr ""
-
-#: gui/main_win.cc:269
-msgid "<b>Save changes before closing?</b>"
-msgstr ""
-
-#: gui/main_win.cc:271
-msgid "Close file _without Saving"
-msgstr ""
-
-#: gui/main_win.cc:458 gui/main_win.cc:487
-msgid "Create New Map - "
-msgstr ""